## iminuit 2.11.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13...3.17)

project(iminuit LANGUAGES CXX)

if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  message(
    WARNING
      "You should call this through setup.py so that all variables are set; python setup.py build_ext --inplace"
  )
endif()

set(CMAKE_CXX_STANDARD
    14
    CACHE STRING "C++ version selection") # or 11, 14, 17, 20
set(CMAKE_CXX_STANDARD_REQUIRED ON) # optional, ensure standard is supported
set(CMAKE_CXX_EXTENSIONS OFF) # optional, keep compiler extensionsn off

# Now we can find pybind11
add_subdirectory(extern/pybind11)

file(GLOB SOURCES_A "src/*.cpp")
set(SOURCES_B
    extern/root/math/minuit2/src/AnalyticalGradientCalculator.cxx
    extern/root/math/minuit2/src/BFGSErrorUpdator.cxx
    extern/root/math/minuit2/src/DavidonErrorUpdator.cxx
    extern/root/math/minuit2/src/HessianGradientCalculator.cxx
    extern/root/math/minuit2/src/ExternalInternalGradientCalculator.cxx
    extern/root/math/minuit2/src/InitialGradientCalculator.cxx
    extern/root/math/minuit2/src/LaEigenValues.cxx
    extern/root/math/minuit2/src/LaInnerProduct.cxx
    extern/root/math/minuit2/src/LaInverse.cxx
    extern/root/math/minuit2/src/LaOuterProduct.cxx
    extern/root/math/minuit2/src/LaSumOfElements.cxx
    extern/root/math/minuit2/src/LaVtMVSimilarity.cxx
    extern/root/math/minuit2/src/MPIProcess.cxx
    extern/root/math/minuit2/src/MinimumBuilder.cxx
    extern/root/math/minuit2/src/MnApplication.cxx
    extern/root/math/minuit2/src/MnContours.cxx
    extern/root/math/minuit2/src/MnCovarianceSqueeze.cxx
    extern/root/math/minuit2/src/MnFcn.cxx
    extern/root/math/minuit2/src/MnFunctionCross.cxx
    extern/root/math/minuit2/src/MnGlobalCorrelationCoeff.cxx
    extern/root/math/minuit2/src/MnHesse.cxx
    extern/root/math/minuit2/src/MnLineSearch.cxx
    extern/root/math/minuit2/src/MnMachinePrecision.cxx
    extern/root/math/minuit2/src/MnMinos.cxx
    extern/root/math/minuit2/src/MnParabolaFactory.cxx
    extern/root/math/minuit2/src/MnParameterScan.cxx
    extern/root/math/minuit2/src/MnPlot.cxx
    extern/root/math/minuit2/src/MnPosDef.cxx
    extern/root/math/minuit2/src/MnPrint.cxx
    extern/root/math/minuit2/src/MnSeedGenerator.cxx
    extern/root/math/minuit2/src/MnStrategy.cxx
    extern/root/math/minuit2/src/MnScan.cxx
    extern/root/math/minuit2/src/MnTiny.cxx
    extern/root/math/minuit2/src/MnTraceObject.cxx
    extern/root/math/minuit2/src/MnUserFcn.cxx
    extern/root/math/minuit2/src/MnUserParameterState.cxx
    extern/root/math/minuit2/src/MnUserParameters.cxx
    extern/root/math/minuit2/src/MnUserTransformation.cxx
    extern/root/math/minuit2/src/ModularFunctionMinimizer.cxx
    extern/root/math/minuit2/src/NegativeG2LineSearch.cxx
    extern/root/math/minuit2/src/Numerical2PGradientCalculator.cxx
    extern/root/math/minuit2/src/SimplexSeedGenerator.cxx
    extern/root/math/minuit2/src/SimplexBuilder.cxx
    extern/root/math/minuit2/src/SimplexParameters.cxx
    extern/root/math/minuit2/src/SinParameterTransformation.cxx
    extern/root/math/minuit2/src/ScanBuilder.cxx
    extern/root/math/minuit2/src/SqrtLowParameterTransformation.cxx
    extern/root/math/minuit2/src/SqrtUpParameterTransformation.cxx
    extern/root/math/minuit2/src/VariableMetricBuilder.cxx
    extern/root/math/minuit2/src/VariableMetricEDMEstimator.cxx
    extern/root/math/minuit2/src/mnbins.cxx
    extern/root/math/minuit2/src/mndasum.cxx
    extern/root/math/minuit2/src/mndaxpy.cxx
    extern/root/math/minuit2/src/mnddot.cxx
    extern/root/math/minuit2/src/mndscal.cxx
    extern/root/math/minuit2/src/mndspmv.cxx
    extern/root/math/minuit2/src/mndspr.cxx
    extern/root/math/minuit2/src/mnlsame.cxx
    extern/root/math/minuit2/src/mnteigen.cxx
    extern/root/math/minuit2/src/mntplot.cxx
    extern/root/math/minuit2/src/mnvert.cxx
    extern/root/math/minuit2/src/mnxerbla.cxx)

pybind11_add_module(_core MODULE ${SOURCES_A} ${SOURCES_B})
if(MSVC)
  target_compile_options(_core PRIVATE /std:c++14 /Y-)
else()
  # lots of warnings from clang and gcc
  target_compile_options(_core PRIVATE -Wall -Wextra -pedantic -Werror
                                       -fstrict-aliasing)
endif()
target_include_directories(_core PRIVATE extern/root/math/minuit2/inc)
set_target_properties(_core PROPERTIES VISIBILITY_INLINES_HIDDEN ON)

=== debian/changelog ===
iminuit (2.11.2-4) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * Build-Depends: python3-tabulate
  * Add salsa-ci.yml
  * Update standards version to 4.6.2, no changes needed.
  * No need for debhelper if debhelper-compat is specified

  [ Ole Streicher ]
  * Fix for newer scipy 1.10 (Closes: #1030174)
  * Add autopkgtests
  * Update changelog for 2.11.2-3 release
  * Mark test_matrix as xfail

 -- Ole Streicher <olebole@debian.org>  Fri, 17 Feb 2023 17:02:03 +0100

iminuit (2.11.2-3) unstable; urgency=medium

  * Team upload.
  * Replace local pybuild11 includes with Debian package (Closes: #1024019)

 -- Ole Streicher <olebole@debian.org>  Tue, 15 Nov 2022 21:10:33 +0100

iminuit (2.11.2-2) unstable; urgency=low

  * source-only re-upload

 -- Jeremy Sanders <jeremy@jeremysanders.net>  Tue, 07 Jun 2022 20:10:00 +0200

iminuit (2.11.2-1) unstable; urgency=low

  * Initial packaging (closes: #968075)

 -- Jeremy Sanders <jeremy@jeremysanders.net>  Mon, 16 May 2022 08:00:00 +0200

=== debian/control ===
Source: iminuit
Section: science
Priority: optional
Homepage: https://github.com/scikit-hep/iminuit
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jeremy Sanders <jeremy@jeremysanders.net>
Vcs-Git: https://salsa.debian.org/science-team/iminuit.git
Vcs-Browser: https://salsa.debian.org/science-team/iminuit
Build-Depends: cmake,
               debhelper-compat (=13),
               dh-exec,
               dh-python,
               python3-all-dev,
               python3-matplotlib,
               python3-numpy,
               python3-pybind11,
               python3-pytest,
               python3-setuptools,
               python3-tabulate <!nocheck>,
Standards-Version: 4.6.2
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-iminuit
Architecture: any
Section: python
Depends: python3-numpy,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Robust Python minimisation library based around MINUIT2
 iminuit is a Jupyter-friendly Python frontend to the MINUIT2 C++ library.
 It can be used as a general robust function minimisation method, but is
 most commonly used for likelihood fits of models to data, and to get model
 parameter error estimates from likelihood profile analysis.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export PYBUILD_NAME=iminuit
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# to ensure hardening
export VERBOSE=1
export CMAKE_ARGS=-DCMAKE_VERBOSE_MAKEFILE=ON
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build: delete_generated
	ln -sf /usr/include/pybind11/ extern/pybind11/include/
	dh_auto_build

override_dh_clean: delete_generated
# force cython code to be regenerated
	rm -f src/iminuit/_libiminuit.cpp
	dh_clean

delete_generated:
# delete files generated by rules
	rm -rf .pytest_cache src/iminuit.egg-info/

=== debian/tests/control ===
Test-Command: cp -r tests $AUTOPKGTEST_TMP && cd $AUTOPKGTEST_TMP && python3 -m pytest tests
Depends: @, python3-pytest

=== debian/watch ===
version=4
opts="pgpmode=none" \
https://pypi.debian.net/iminuit/iminuit-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## iminuit 2.24.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
-cmake_minimum_required(VERSION 3.13...3.17)
+cmake_minimum_required(VERSION 3.15...3.26)
 
 project(iminuit LANGUAGES CXX)
 
-if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
+if(NOT DEFINED SKBUILD)
   message(
     WARNING
-      "You should call this through setup.py so that all variables are set; python setup.py build_ext --inplace"
+      "You should call this through Python so that all variables are set; pip install -v ."
   )
 endif()
 
@@ -15,8 +15,7 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON) # optional, ensure standard is supported
 set(CMAKE_CXX_EXTENSIONS OFF) # optional, keep compiler extensionsn off
 
-# Now we can find pybind11
-add_subdirectory(extern/pybind11)
+find_package(pybind11 CONFIG REQUIRED)
 
 file(GLOB SOURCES_A "src/*.cpp")
 set(SOURCES_B
@@ -93,3 +92,5 @@
 endif()
 target_include_directories(_core PRIVATE extern/root/math/minuit2/inc)
 set_target_properties(_core PROPERTIES VISIBILITY_INLINES_HIDDEN ON)
+
+install(TARGETS _core DESTINATION iminuit)

=== Makefile ===
# Makefile for developers with some convenient quick ways to do common things

# default target
build/done: $(wildcard *.py src/*.cpp extern/root/math/minuit2/src/*.cxx extern/root/math/minuit2/inc/*.h) CMakeLists.txt
	mkdir -p build
	python .ci/install_deps.py build
	DEBUG=1 CMAKE_BUILD_PARALLEL_LEVEL=8 CMAKE_ARGS="-DCMAKE_CXX_COMPILER_LAUNCHER=ccache" python -m pip install --no-build-isolation -v -e .
	touch build/done

build/testdep: build/done
	python .ci/install_deps.py test
	touch build/testdep

test: build/done build/testdep
	JUPYTER_PLATFORM_DIRS=1 python -m pytest -vv -r a --ff --pdb

# this requires that ROOT is installed
bench: build/done build/testdep
	python -m pytest bench --benchmark-autosave

# only computes the coverage in pure Python
cov: build/done build/testdep
	rm -rf htmlcov
	JUPYTER_PLATFORM_DIRS=1 coverage run -m pytest
	coverage html -d htmlcov
	coverage report -m
	@echo htmlcov/index.html

doc: build/done build/html/done
	@echo build/html/index.html

build/docdep: build/done
	python .ci/install_deps.py test doc
	touch build/docdep

build/html/done: build/done build/docdep doc/conf.py $(wildcard src/iminuit/*.py doc/*.rst doc/_static/* doc/plots/* doc/notebooks/*.ipynb doc/notebooks/roofit/*.ipynb *.rst)
	mkdir -p build/html
	sphinx-build -v -W -b html -d build/doctrees doc build/html
	touch build/html/done

tutorial: build/done build/tutorial_done

build/tutorial_done: $(wildcard src/iminuit/*.py doc/tutorial/*.ipynb)
	python3 -m pytest -n8 doc/tutorial
	touch build/tutorial_done

check:
	pre-commit run -a

clean:
	rm -rf build htmlcov src/iminuit/_core* tutorial/.ipynb_checkpoints iminuit.egg-info src/iminuit.egg-info .pytest_cache src/iminuit/__pycache__ tests/__pycache__ tutorial/__pycache__ .coverage .eggs .ipynb_checkpoints dist __pycache__

.PHONY: clean check cov doc test bench

=== extern/root/math/minuit2/src/CMakeLists.txt ===
# Copyright (C) 1995-2019, Rene Brun and Fons Rademakers.
# All rights reserved.
#
# For the licensing terms see $ROOTSYS/LICENSE.
# For the list of contributors see $ROOTSYS/README/CREDITS.

add_subdirectory(math)

set(MINUIT2_HEADERS
    ABObj.h
    ABProd.h
    ABSum.h
    ABTypes.h
    AnalyticalGradientCalculator.h
    BFGSErrorUpdator.h
    CombinedMinimizer.h
    CombinedMinimumBuilder.h
    ContoursError.h
    DavidonErrorUpdator.h
    ExternalInternalGradientCalculator.h
    FCNAdapter.h
    FCNBase.h
    FCNGradAdapter.h
    FCNGradientBase.h
    FumiliBuilder.h
    FumiliChi2FCN.h
    FumiliErrorUpdator.h
    FumiliFCNAdapter.h
    FumiliFCNBase.h
    FumiliGradientCalculator.h
    FumiliMaximumLikelihoodFCN.h
    FumiliMinimizer.h
    FumiliStandardChi2FCN.h
    FumiliStandardMaximumLikelihoodFCN.h
    FunctionGradient.h
    FunctionMinimizer.h
    FunctionMinimum.h
    GenericFunction.h
    GradientCalculator.h
    HessianGradientCalculator.h
    InitialGradientCalculator.h
    LASymMatrix.h
    LAVector.h
    LaInverse.h
    LaOuterProduct.h
    LaProd.h
    LaSum.h
    MPIProcess.h
    MatrixInverse.h
    MinimumBuilder.h
    MinimumError.h
    MinimumErrorUpdator.h
    MinimumParameters.h
    MinimumSeed.h
    MinimumSeedGenerator.h
    MinimumState.h
    MinosError.h
    Minuit2Minimizer.h
    MinuitParameter.h
    MnApplication.h
    MnConfig.h
    MnContours.h
    MnCovarianceSqueeze.h
    MnCross.h
    MnEigen.h
    MnFcn.h
    MnFumiliMinimize.h
    MnFunctionCross.h
    MnGlobalCorrelationCoeff.h
    MnHesse.h
    MnLineSearch.h
    MnMachinePrecision.h
    MnMatrix.h
    MnMigrad.h
    MnMinimize.h
    MnMinos.h
    MnParabola.h
    MnParabolaFactory.h
    MnParabolaPoint.h
    MnParameterScan.h
    MnPlot.h
    MnPosDef.h
    MnPrint.h
    MnScan.h
    MnSeedGenerator.h
    MnSimplex.h
    MnStrategy.h
    MnTiny.h
    MnTraceObject.h
    MnUserCovariance.h
    MnUserFcn.h
    MnUserParameterState.h
    MnUserParameters.h
    MnUserTransformation.h
    MnVectorTransform.h
    ModularFunctionMinimizer.h
    NegativeG2LineSearch.h
    Numerical2PGradientCalculator.h
    ParametricFunction.h
    ScanBuilder.h
    ScanMinimizer.h
    SimplexBuilder.h
    SimplexMinimizer.h
    SimplexParameters.h
    SimplexSeedGenerator.h
    SinParameterTransformation.h
    SqrtLowParameterTransformation.h
    SqrtUpParameterTransformation.h
    StackAllocator.h
    VariableMetricBuilder.h
    VariableMetricEDMEstimator.h
    VariableMetricMinimizer.h
    VectorOuterProduct.h
    )

set(MINUIT2_SOURCES
    AnalyticalGradientCalculator.cxx
    BFGSErrorUpdator.cxx
    CombinedMinimumBuilder.cxx
    DavidonErrorUpdator.cxx
    ExternalInternalGradientCalculator.cxx
    FumiliBuilder.cxx
    FumiliErrorUpdator.cxx
    FumiliGradientCalculator.cxx
    FumiliMinimizer.cxx
    FumiliStandardChi2FCN.cxx
    FumiliStandardMaximumLikelihoodFCN.cxx
    HessianGradientCalculator.cxx
    InitialGradientCalculator.cxx
    LaEigenValues.cxx
    LaInnerProduct.cxx
    LaInverse.cxx
    LaOuterProduct.cxx
    LaSumOfElements.cxx
    LaVtMVSimilarity.cxx
    MPIProcess.cxx
    MinimumBuilder.cxx
    Minuit2Minimizer.cxx
    MnApplication.cxx
    MnContours.cxx
    MnCovarianceSqueeze.cxx
    MnEigen.cxx
    MnFcn.cxx
    MnFumiliMinimize.cxx
    MnFunctionCross.cxx
    MnGlobalCorrelationCoeff.cxx
    MnHesse.cxx
    MnLineSearch.cxx
    MnMachinePrecision.cxx
    MnMinos.cxx
    MnParabolaFactory.cxx
    MnParameterScan.cxx
    MnPlot.cxx
    MnPosDef.cxx
    MnPrint.cxx
    MnPrintImpl.cxx
    MnScan.cxx
    MnSeedGenerator.cxx
    MnStrategy.cxx
    MnTiny.cxx
    MnTraceObject.cxx
    MnUserFcn.cxx
    MnUserParameterState.cxx
    MnUserParameters.cxx
    MnUserTransformation.cxx
    ModularFunctionMinimizer.cxx
    NegativeG2LineSearch.cxx
    Numerical2PGradientCalculator.cxx
    ParametricFunction.cxx
    ScanBuilder.cxx
    SimplexBuilder.cxx
    SimplexParameters.cxx
    SimplexSeedGenerator.cxx
    SinParameterTransformation.cxx
    SqrtLowParameterTransformation.cxx
    SqrtUpParameterTransformation.cxx
    VariableMetricBuilder.cxx
    VariableMetricEDMEstimator.cxx
    mnbins.cxx
    mndasum.cxx
    mndaxpy.cxx
    mnddot.cxx
    mndscal.cxx
    mndspmv.cxx
    mndspr.cxx
    mnlsame.cxx
    mnteigen.cxx
    mntplot.cxx
    mnvert.cxx
    mnxerbla.cxx
    )

prepend_path(MINUIT2_HEADERS "${Minuit2_SOURCE_DIR}/inc/Minuit2" ${MINUIT2_HEADERS})
prepend_path(MINUIT2_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}" ${MINUIT2_SOURCES})

add_library(Minuit2
    ${MINUIT2_SOURCES}
    ${MINUIT2_HEADERS}
    )

# Add alias for direct inclusion with add_subdirectory
add_library(Minuit2::Minuit2 ALIAS Minuit2)

target_include_directories(
    Minuit2
    PUBLIC
    $<BUILD_INTERFACE:${Minuit2_SOURCE_DIR}/inc>
    $<INSTALL_INTERFACE:include/Minuit2>
    )

target_compile_features(Minuit2 PUBLIC cxx_nullptr cxx_nonstatic_member_init)
set_target_properties(Minuit2 PROPERTIES CXX_EXTENSIONS OFF)

target_link_libraries(Minuit2 PUBLIC Minuit2Math Minuit2Common)

install(TARGETS Minuit2
        EXPORT Minuit2Targets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        )

install(FILES ${MINUIT2_HEADERS} DESTINATION include/Minuit2/Minuit2)

=== extern/root/math/minuit2/src/math/CMakeLists.txt ===
# Copyright (C) 1995-2019, Rene Brun and Fons Rademakers.
# All rights reserved.
#
# For the licensing terms see $ROOTSYS/LICENSE.
# For the list of contributors see $ROOTSYS/README/CREDITS.


set(FIT_HEADERS
    ParameterSettings.h
    )

set(MATH_HEADERS
    Error.h
    FitMethodFunction.h
    Functor.h
    GenAlgoOptions.h
    IFunction.h
    IFunctionfwd.h
    IOptions.h
    Minimizer.h
    MinimizerOptions.h
    Util.h
    WrappedFunction.h
    WrappedParamFunction.h
    )

set(MATH_SOURCES
    GenAlgoOptions.cxx
    MinimizerOptions.cxx
    )

copy_standalone(SOURCE ../../../mathcore/inc/Fit DESTINATION ../../inc/Fit
    OUTPUT FIT_HEADERS
    FILES ${FIT_HEADERS})
copy_standalone(SOURCE ../../../mathcore/inc/Math DESTINATION ../../inc/Math
    OUTPUT  MATH_HEADERS
    FILES ${MATH_HEADERS})
copy_standalone(SOURCE ../../../mathcore/src DESTINATION .
    OUTPUT MATH_SOURCES
    FILES ${MATH_SOURCES})

# Adding the headers helps IDEs show the correct headers on targets
add_library(Minuit2Math
    ${MATH_SOURCES}
    ${MATH_HEADERS}
    ${FIT_HEADERS}
    )

# Add alias for direct inclusion
add_library(Minuit2::Math ALIAS Minuit2Math)

# Build and install directories are different, using CMake Generator expression
target_include_directories(
    Minuit2Math
    PUBLIC
    $<BUILD_INTERFACE:${Minuit2_SOURCE_DIR}/inc>
    $<INSTALL_INTERFACE:include/Minuit2>
    )

# We need to add the ROOT mathcore directories if build inside of ROOT without standalone)
if(minuit2_inroot AND NOT minuit2_standalone)
    target_include_directories(
        Minuit2Math
        PUBLIC
        $<BUILD_INTERFACE:${Minuit2_SOURCE_DIR}/../mathcore/inc>
        )
endif()

target_compile_definitions(
    Minuit2Math
    PRIVATE
    MATH_NO_PLUGIN_MANAGER
    )

target_compile_definitions(
    Minuit2Math
    PUBLIC
    ROOT_Math_VecTypes
    MATHCORE_STANDALONE
    )

target_link_libraries(Minuit2Math PUBLIC Minuit2Common)

target_compile_features(Minuit2Math PUBLIC cxx_auto_type cxx_static_assert)
set_target_properties(Minuit2Math PROPERTIES CXX_EXTENSIONS OFF)

install(TARGETS Minuit2Math
        EXPORT Minuit2Targets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        )

install(FILES ${FIT_HEADERS} DESTINATION include/Minuit2/Fit)
install(FILES ${MATH_HEADERS} DESTINATION include/Minuit2/Math)

=== debian/changelog ===
iminuit (2.24.0-2) unstable; urgency=medium

  * Disable numba everywhere except amd64, i386 and ppc64el
  * Skip test that fails on arm64 and ppc64el

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 23 Aug 2023 18:03:13 +0200

iminuit (2.24.0-1) unstable; urgency=medium

  * New upstream version 2.24.0
  * Drop old patches for testsuite

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 23 Aug 2023 13:07:41 +0200

iminuit (2.22.0-2) unstable; urgency=medium

  * Try to fix _safe_log for low precision architectures
  * Fix missing dpkg CPPFLAGS

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 05 Jul 2023 01:36:33 +0200

iminuit (2.22.0-1) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * New upstream version 2.18.0

  [ Stephan Lachnit ]
  * Remove pybind11 from tarball
  * New upstream version 2.22.0

 -- Stephan Lachnit <stephanlachnit@debian.org>  Mon, 03 Jul 2023 23:39:55 +0200

=== debian/control ===
Source: iminuit
Section: science
Priority: optional
Homepage: https://github.com/scikit-hep/iminuit
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jeremy Sanders <jeremy@jeremysanders.net>,
           Stephan Lachnit <stephanlachnit@debian.org>
Vcs-Git: https://salsa.debian.org/science-team/iminuit.git
Vcs-Browser: https://salsa.debian.org/science-team/iminuit
Build-Depends: cmake,
               debhelper-compat (=13),
               dh-sequence-python3,
               pybuild-plugin-pyproject,
               python3-all-dev,
               python3-ipykernel <!nocheck>,
#               python3-ipywidgets <!nocheck>, needs ipywidgets v8 (#896460)
               python3-matplotlib <!nocheck>,
               python3-numba [amd64 i386 ppc64el] <!nocheck>,
               python3-numpy <!nocheck>,
               python3-pybind11,
#               python3-pydantic <!nocheck>, needs python3-annotated-types (#1050339)
               python3-pytest <!nocheck>,
               python3-scipy <!nocheck>,
               python3-setuptools,
               python3-tabulate <!nocheck>,
Standards-Version: 4.6.2
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-iminuit
Architecture: any
Section: python
Depends: python3-numpy,
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Recommends: python3-ipywidgets (>= 8.0.0),
            python3-matplotlib,
            python3-numba [amd64 i386 ppc64el],
            python3-scipy,
Description: Robust Python minimisation library based around MINUIT2
 iminuit is a Jupyter-friendly Python frontend to the MINUIT2 C++ library.
 It can be used as a general robust function minimisation method, but is
 most commonly used for likelihood fits of models to data, and to get model
 parameter error estimates from likelihood profile analysis.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export PYBUILD_NAME=iminuit
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# to ensure hardening
export VERBOSE=1
export CMAKE_ARGS=-DCMAKE_BUILD_TYPE=None -DCMAKE_VERBOSE_MAKEFILE=ON
export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ --with python3 --buildsystem=pybuild

=== debian/tests/control ===
Tests: pytest
Depends: python3-iminuit,
         python3-pytest,
         python3-ipykernel,
#         python3-ipywidgets, needs ipywidgets v8 (#896460)
         python3-matplotlib,
         python3-numba [amd64 i386 ppc64el],
#         python3-pydantic, needs python3-annotated-types (#1050339)
         python3-scipy,
         python3-tabulate,

## iminuit 2.30.0

=== debian/changelog ===
iminuit (2.30.0-1build1) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 15 Nov 2024 04:38:26 +0100

iminuit (2.30.0-1) unstable; urgency=medium

  * Team upload
  * New upstream version 2.30.0
  * Remove old patches and switch from python3-setuptools to python3-skbuild

 -- Alexandre Detiste <tchet@debian.org>  Mon, 30 Sep 2024 16:59:59 +0200

iminuit (2.24.0-3) unstable; urgency=medium

  * Team upload
  * Disable numba, not yet compatible with Python 3.12
  * Ignore DeprecationWarnings during build-time tests to avoid
    FTBFS with Python 3.12

 -- Graham Inggs <ginggs@debian.org>  Mon, 11 Dec 2023 15:53:11 +0000

=== debian/control ===
--- 
+++ 
@@ -15,13 +15,13 @@
                python3-ipykernel <!nocheck>,
 #               python3-ipywidgets <!nocheck>, needs ipywidgets v8 (#896460)
                python3-matplotlib <!nocheck>,
-               python3-numba [amd64 i386 ppc64el] <!nocheck>,
+#               python3-numba [amd64 i386 ppc64el] <!nocheck>,
                python3-numpy <!nocheck>,
                python3-pybind11,
 #               python3-pydantic <!nocheck>, needs python3-annotated-types (#1050339)
                python3-pytest <!nocheck>,
                python3-scipy <!nocheck>,
-               python3-setuptools,
+               python3-scikit-build-core,
                python3-tabulate <!nocheck>,
 Standards-Version: 4.6.2
 Testsuite: autopkgtest-pkg-python

## iminuit 2.30.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,12 +9,15 @@
   )
 endif()
 
+include(CheckIPOSupported)
+check_ipo_supported(RESULT ipo_supported OUTPUT error)
+
 set(CMAKE_CXX_STANDARD
     14
     CACHE STRING "C++ version selection") # or 11, 14, 17, 20
 set(CMAKE_CXX_STANDARD_REQUIRED ON) # optional, ensure standard is supported
 set(CMAKE_CXX_EXTENSIONS OFF) # optional, keep compiler extensionsn off
-
+set(PYBIND11_FINDPYTHON ON)
 find_package(pybind11 CONFIG REQUIRED)
 
 file(GLOB SOURCES_A "src/*.cpp")
@@ -83,14 +86,35 @@
     extern/root/math/minuit2/src/mnxerbla.cxx)
 
 pybind11_add_module(_core MODULE ${SOURCES_A} ${SOURCES_B})
+
+target_include_directories(_core PRIVATE extern/root/math/minuit2/inc)
+target_compile_definitions(_core PUBLIC PYBIND11_DETAILED_ERROR_MESSAGES=1)
+set_target_properties(_core PROPERTIES VISIBILITY_INLINES_HIDDEN ON)
+if(ipo_supported)
+  set_target_properties(_core PROPERTIES INTERPROCEDURAL_OPTIMIZATION TRUE)
+endif()
+
+# Add compiler-specific extra warnings
 if(MSVC)
   target_compile_options(_core PRIVATE /std:c++14 /Y-)
+elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+  # lots of warnings from gcc, including odr violations
+  target_compile_options(
+    _core
+    PRIVATE -Wall
+            -Wextra
+            -Werror
+            -Werror=odr
+            -Werror=lto-type-mismatch
+            -Werror=strict-aliasing
+            -pedantic
+            -fstrict-aliasing)
+  target_link_options(_core PRIVATE -Werror -Wodr -Wlto-type-mismatch)
 else()
-  # lots of warnings from clang and gcc
+  # lots of warnings from clang
   target_compile_options(_core PRIVATE -Wall -Wextra -pedantic -Werror
-                                       -fstrict-aliasing)
+                                       -Werror=odr -fstrict-aliasing)
+  target_link_options(_core PRIVATE -Werror -Wodr)
 endif()
-target_include_directories(_core PRIVATE extern/root/math/minuit2/inc)
-set_target_properties(_core PROPERTIES VISIBILITY_INLINES_HIDDEN ON)
 
 install(TARGETS _core DESTINATION iminuit)

=== extern/root/math/minuit2/src/math/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,10 @@
 
 set(MATH_SOURCES
     GenAlgoOptions.cxx
+    IOptions.cxx
+    Minimizer.cxx
     MinimizerOptions.cxx
+    ParameterSettings.cxx
     )
 
 copy_standalone(SOURCE ../../../mathcore/inc/Fit DESTINATION ../../inc/Fit
@@ -86,8 +89,8 @@
 
 install(TARGETS Minuit2Math
         EXPORT Minuit2Targets
-        LIBRARY DESTINATION lib
-        ARCHIVE DESTINATION lib
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
         )
 
 install(FILES ${FIT_HEADERS} DESTINATION include/Minuit2/Fit)

=== debian/changelog ===
iminuit (2.30.1-3build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:08:01 +0000

iminuit (2.30.1-3) unstable; urgency=medium

  * Team upload.
  * Skip flaky test (xfail seems not to be enough). Closes: #1095348.

 -- Santiago Vila <sanvila@debian.org>  Fri, 21 Mar 2025 14:30:00 +0100

iminuit (2.30.1-2) unstable; urgency=medium

  * Team upload.
  * Mark flaky test as xfail. Closes: #1095348.

 -- Santiago Vila <sanvila@debian.org>  Fri, 21 Mar 2025 13:20:00 +0100

iminuit (2.30.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.30.1 (Closes: #1095348)
  * Fix license name for BSD-2-Clause in d/copyright
  * Push Standards-Version to 4.7.2, no changes needed

 -- Ole Streicher <olebole@debian.org>  Sun, 09 Mar 2025 12:51:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,10 @@
 Source: iminuit
-Section: science
-Priority: optional
-Homepage: https://github.com/scikit-hep/iminuit
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jeremy Sanders <jeremy@jeremysanders.net>,
            Stephan Lachnit <stephanlachnit@debian.org>
-Vcs-Git: https://salsa.debian.org/science-team/iminuit.git
-Vcs-Browser: https://salsa.debian.org/science-team/iminuit
+Section: science
+Testsuite: autopkgtest-pkg-python
+Priority: optional
 Build-Depends: cmake,
                debhelper-compat (=13),
                dh-sequence-python3,
@@ -22,9 +20,11 @@
                python3-pytest <!nocheck>,
                python3-scipy <!nocheck>,
                python3-scikit-build-core,
-               python3-tabulate <!nocheck>,
-Standards-Version: 4.6.2
-Testsuite: autopkgtest-pkg-python
+               python3-tabulate <!nocheck>
+Standards-Version: 4.7.2
+Vcs-Browser: https://salsa.debian.org/science-team/iminuit
+Vcs-Git: https://salsa.debian.org/science-team/iminuit.git
+Homepage: https://github.com/scikit-hep/iminuit
 Rules-Requires-Root: no
 
 Package: python3-iminuit
@@ -33,11 +33,11 @@
 Depends: python3-numpy,
          ${python3:Depends},
          ${shlibs:Depends},
-         ${misc:Depends},
+         ${misc:Depends}
 Recommends: python3-ipywidgets (>= 8.0.0),
             python3-matplotlib,
             python3-numba [amd64 i386 ppc64el],
-            python3-scipy,
+            python3-scipy
 Description: Robust Python minimisation library based around MINUIT2
  iminuit is a Jupyter-friendly Python frontend to the MINUIT2 C++ library.
  It can be used as a general robust function minimisation method, but is

=== debian/tests/control ===
Tests: pytest
Depends: python3-iminuit,
         python3-pytest,
         python3-ipykernel,
#         python3-ipywidgets, needs ipywidgets v8 (#896460)
         python3-matplotlib,
#         python3-numba [amd64 i386 ppc64el],
#         python3-pydantic, needs python3-annotated-types (#1050339)
         python3-scipy,
         python3-tabulate,

=== debian/watch ===
version=4
opts="pgpmode=none" \
https://pypi.debian.net/iminuit/iminuit-v?@ANY_VERSION@@ARCHIVE_EXT@
